#include "dumptrans.h"

/*
 * dumptrans.c
 *
 * program that dumps the contents of an account
 */

void main(int argc, char *argv[])
{
  int datum, porc, mdamount, damount;
  char *mdacct, *dacct, *mdanal, *danal;
  char *pgDatum;
  char minibuff[513];
  char *buffDesig1;
  char *buffDesig2;

  pgDatum = malloc(11);
  buffDesig1 = malloc(31);
  buffDesig2 = malloc(61);

  if (argc < 3) {
    fprintf(stderr, "Usage: %s [datum poradove_cislo]\n", argv[0]);
    exit(0);
  }

  /* check validity of supplied date */
  datum = atoi(argv[1]);
  porc = atoi(argv[2]);
  if (!(valiDate(datum))) {
    fprintf(stderr, "Zadane datum je spatne.\n");
    exit(0);
  }
  if ((porc < 1) || (porc > 999)) {
    fprintf(stderr, "Zadan poadov slo je pravdpodobn patn.\n");
    exit(0);
  }

  initBackend();                /* initialize the backend connection */

  if (!transQuery(datum, porc)) {
    fprintf(stderr, "There is no transaction %d:%03d in the database.\n", datum, porc);
    exit_nicely();
  }
  sprintf(minibuff, "SELECT desig FROM descs WHERE ent_date='%s' and por_cislo=%d;", pgConvertDate(pgDatum, datum), porc);
  runQuery(minibuff);
  printf("%d:%03d %-30s\n", datum, porc, getField("desig"));
  printf("-----------------------------------------------------------------\n");
  sprintf(minibuff, "DECLARE a1 CURSOR FOR SELECT ent_date, por_cislo, md_acct, md_anal, md_amt, d_acct, d_anal, d_amt FROM denik WHERE ent_date='%s' AND por_cislo=%d ORDER BY ent_date, por_cislo;", pgConvertDate(pgDatum, datum), porc);
  startTransaction();
  runQuery(minibuff);
  while (fetchNext("a1")) {
    if ((mdamount = atoi(getField("md_amt"))) > 0) {
      mdacct = getField("md_acct");
      mdanal = getField("md_anal");
      printf("%s %s|%-30s|%10d.%02d|\n", mdacct, mdanal, strncpy(buffDesig1, acctQuery(buffDesig2, mdacct, mdanal), 30), (mdamount/100), (mdamount%100));
    } else {
      dacct = getField("d_acct");
      danal = getField("d_anal");
      if ((damount = atoi(getField("d_amt"))) > 0) {
	printf("%s %s|%-30s|             |%10d.%02d\n", dacct, danal, strncpy(buffDesig1, acctQuery(buffDesig2, dacct, danal), 30), (damount/100), (damount%100));
      } else {
	fprintf(stderr, "Corrupt database: either credit or debit side must = 0 in 'denik'");
	exit_nicely();
      }
    }
  }

  endTransaction();
  
  exit_nicely();
}
      
