#include "rmtrans.h"

/*
 * rmtrans
 *
 * program to delete a transaction
 */

void main(int argc, char *argv[])
{
  int datum;
  int porc;

  /* primary basic check of arguments */
  if (argc < 3) {
    fprintf(stderr, "Usage: %s [datum poradove_cislo]\n", argv[0]);
    exit(1);
  }

  /* convert arguments to integers */
  datum = atoi(argv[1]);
  porc = atoi(argv[2]);

  /* argument no. 1 must be a valid date */
  if (!valiDate(datum)) {
    fprintf(stderr, "First argument must be a valid date.");
    exit(1);
  }

  /* initializion of database */
  initBackend();

  if (!transQuery(datum, porc)) {
    fprintf(stderr, "Transaction %d:%03d is not in the database.\n", datum, porc);
    exit_nicely();
  }
  deleteTrans(datum, porc);

  exit_nicely();
}

void deleteTrans(int datum, int porc)
{
  char miscbuff[81];
  int resultcode;
  char *pgDatum;

  pgDatum = malloc(11);
  pgDatum = pgConvertDate(pgDatum, datum);

  printf("Deleting transaction number %d:%03d from table 'descs'...\n", datum, porc);

  startTransaction();
  sprintf(miscbuff, "DELETE FROM descs WHERE ent_date='%s' and por_cislo=%d;", pgDatum, porc);
  resultcode = runQueryInTrans(miscbuff);
  if (resultcode == 2) {
    printf("Delete command successful.\n");
  } else {
    fprintf(stderr, "Delete command returned (%d), which is not what I expected.\n", resultcode);
    fprintf(stderr, "Rolling back transaction and bailing out.");
    rollbackTransaction();
    exit_nicely();
  }
  printf("Deleting transaction number %d:%03d from table 'denik'...\n", datum, porc);
  sprintf(miscbuff, "DELETE FROM denik WHERE ent_date='%s' and por_cislo=%d;", pgDatum, porc);
  resultcode = runQueryInTrans(miscbuff);
  if (resultcode == 2) {
    printf("Delete command successful.\n");
  } else {
    fprintf(stderr, "Delete command returned (%d), which is not what I expected.\n", resultcode);
    fprintf(stderr, "Rolling back transaction and bailing out.");
    rollbackTransaction();
    exit_nicely();
  }
  endTransaction();
  return;
}



